"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AsyncTest2 = exports.AsyncTest1 = void 0;
/* eslint-disable indent */
/* eslint-disable react/jsx-indent */
/* eslint-disable react/jsx-one-expression-per-line */
/* eslint-disable no-unused-vars */
/* eslint-disable react/prop-types */
const react_1 = __importDefault(require("react"));
const use_async_object_manager_1 = require("./use-async-object-manager");
function timeout(response, ms) {
    return new Promise((resolve) => setTimeout(() => resolve(response), ms));
}
const demoLoadedData = { goodbye: 'newworld' };
const asyncGetDocument = () => __awaiter(void 0, void 0, void 0, function* () { return timeout(demoLoadedData, 1000); });
const asyncPutDocument = () => __awaiter(void 0, void 0, void 0, function* () { return timeout({ ok: true }, 1000); });
const asyncPostDocument = () => __awaiter(void 0, void 0, void 0, function* () { return timeout({ ok: true }, 1000); });
const asyncDeleteDocument = () => __awaiter(void 0, void 0, void 0, function* () { return timeout({ ok: true }, 1000); });
const Viz = ({ loadedData, saveData, updateData, updateFormData, resetData, reload, deleteObject, saveResponse, deleteResponse, loadingData, savingData, deletingData, data, uid, callCount, }) => (react_1.default.createElement("div", null,
    uid,
    react_1.default.createElement("button", { type: "button", className: "button-one", onClick: reload }, "Reload data"),
    react_1.default.createElement("div", null, loadingData ? 'loading data' : 'Loaded data'),
    react_1.default.createElement("div", null,
        "Loaded data:",
        JSON.stringify(loadedData)),
    react_1.default.createElement("div", null,
        "data:",
        JSON.stringify(data)),
    react_1.default.createElement("div", null,
        "Callcount: ",
        callCount)));
const defaultArgs = {
    activeUid: 'demouid',
    collection: 'democollection',
    isNew: false,
    inputAdditionalData: {},
    schema: 'all',
    loadOnInit: false,
    asyncGetDocument,
    asyncPutDocument,
    asyncPostDocument,
    asyncDeleteDocument,
};
const AsyncTest1 = () => {
    // return <div>Hello</div>
    const { loadedData, saveData, updateData, updateFormData, resetData, reload, deleteObject, saveResponse, deleteResponse, loadingData, savingData, deletingData, data, uid, callCount, } = (0, use_async_object_manager_1.useAsyncObjectManager)(defaultArgs);
    return (react_1.default.createElement(Viz, { loadedData: loadedData, saveData: saveData, updateData: updateData, updateFormData: updateFormData, resetData: resetData, reload: reload, deleteObject: deleteObject, saveResponse: saveResponse, deleteResponse: deleteResponse, loadingData: loadingData, savingData: savingData, deletingData: deletingData, data: data, uid: uid, callCount: callCount }));
};
exports.AsyncTest1 = AsyncTest1;
const AsyncTest2 = () => {
    const { loadedData, saveData, updateData, updateFormData, resetData, reload, deleteObject, saveResponse, deleteResponse, loadingData, savingData, deletingData, data, uid, callCount, } = (0, use_async_object_manager_1.useAsyncObjectManager)(Object.assign(Object.assign({}, defaultArgs), { loadOnInit: true }));
    return (react_1.default.createElement(Viz, { loadedData: loadedData, saveData: saveData, updateData: updateData, updateFormData: updateFormData, resetData: resetData, reload: reload, deleteObject: deleteObject, saveResponse: saveResponse, deleteResponse: deleteResponse, loadingData: loadingData, savingData: savingData, deletingData: deletingData, data: data, uid: uid, callCount: callCount }));
};
exports.AsyncTest2 = AsyncTest2;
//# sourceMappingURL=use-async-object-manager.composition.js.map